SystemOrganization addCategory: #'Rizel-Example'!

RizelAbstractModel subclass: #RizelTestScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Example'!

!RizelTestScenario methodsFor: 'bench' stamp: ''!
benchmark1
	(self buildPendrive
		collect: [:t1 | t1 class = RSTextFile])
		do: #open! !

!RizelTestScenario methodsFor: 'bench' stamp: ''!
benchmark2
	(self buildPendrive
		collect: [:t1 | t1 class = RSMP3File])
		do: #open! !

!RizelTestScenario methodsFor: 'bench' stamp: ''!
benchmark3
	(self buildPendrive
		collect: [:t1 | t1 class = RSImageFile])
		do: #open! !

!RizelTestScenario methodsFor: 'bench' stamp: ''!
benchmark4
	(self buildPendrive
		collect: [:t1 | t1 class = RSMP4File])
		do: #open! !

!RizelTestScenario methodsFor: 'bench' stamp: ''!
buildPendrive
	| t1 t2 t3 t4 t5 |
	t1 := RSPenDrive new.
	t2 := RSDirectory new.
	t2
		add: (RSMP3File named: 'MP3A' size: 10).
	t2
		add: (RSMP3File named: 'MP3B' size: 10).
	t2
		add: (RSMP3File named: 'MP3C' size: 10).
	t2
		add: (RSMP3File named: 'MP3D' size: 10).
	t2
		add: (RSMP3File named: 'MP3E' size: 10).
	t2
		add: (RSMP3File named: 'MP3F' size: 10).
	t3 := RSDirectory new.
	t3
		add: (RSMP4File named: 'MP4A' size: 10).
	t3
		add: (RSMP4File named: 'MP4B' size: 10).
	t3
		add: (RSMP4File named: 'MP4C' size: 10).
	t3
		add: (RSMP4File named: 'MP4D' size: 10).
	t3
		add: (RSMP4File named: 'MP4E' size: 10).
	t3
		add: (RSMP4File named: 'MP4F' size: 10).
	t4 := RSDirectory new.
	t4
		add: (RSTextFile named: 'TextA' size: 10).
	t4
		add: (RSTextFile named: 'TextB' size: 10).
	t4
		add: (RSTextFile named: 'TextC' size: 10).
	t4
		add: (RSTextFile named: 'TextD' size: 10).
	t4
		add: (RSTextFile named: 'TextE' size: 10).
	t4
		add: (RSTextFile named: 'TextF' size: 10).
	t5 := RSDirectory new.
	t5
		add: (RSImageFile named: 'ImageA' size: 10).
	t5
		add: (RSImageFile named: 'ImageB' size: 10).
	t5
		add: (RSImageFile named: 'ImageC' size: 10).
	t5
		add: (RSImageFile named: 'ImageD' size: 10).
	t5
		add: (RSImageFile named: 'ImageE' size: 10).
	t5
		add: (RSImageFile named: 'ImageF' size: 10).
	t1 add: t2.
	t1 add: t3.
	t1 add: t4.
	t1 add: t5.
	^ t1! !

!RizelTestScenario methodsFor: 'rizel' stamp: ''!
configurationClass
	^ ConfigurationOfRizel! !

!RizelTestScenario methodsFor: 'rizel' stamp: ''!
loadVersion: t1 
	Gofer new url: 'http://ss3.gemstone.com/ss/Rizel';
		 version: 'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.' , t1;
		 load! !

!RizelTestScenario methodsFor: 'rizel' stamp: ''!
profile: t1 in: t2 
	self loadVersion: t2.
	Smalltalk garbageCollect.
	^ self profilerClass
		profile: [self
				executeBenchmark: [self perform: t1]]
		inPackagesMatching: 'Rizel-Test-Scenario'! !

!RizelTestScenario methodsFor: 'rizel' stamp: ''!
versionLabel
	^ [:t1 | t1]! !

!RizelTestScenario methodsFor: 'rizel' stamp: ''!
versions
	^ #('1' '2' '3' '4' '5' )! !

Object subclass: #RzExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Example'!

!RzExamples methodsFor: 'scenario' stamp: ''!
addressBookXML
	^ '<addressbook>
  <person employee-number="A0000" family-name="Gates" first-name="Bob">
    <contact-info><!!--Confidential--></contact-info>
    <address city="Los Angeles" number="1239" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Manager"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7000" family-name="Brown"
    first-name="Robert" middle-initial="L.">
    <contact-info>
      <email address="robb@iro.ibm.com"/>
      <home-phone number="03-3987873"/>
    </contact-info>
    <address city="New York" number="344" state="NY" street="118 St."/>
    <job-info employee-type="Full-Time" is-manager="yes" job-description="Group Leader"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7890" family-name="DePaiva"
    first-name="Kassie" middle-initial="W.">
    <contact-info><!!-- Kassie''s agent phone: 03-987654 --></contact-info>
    <address city="Los Angeles" number="1234" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Actor"/>
    <manager employee-number="A0000"/>
    <misc-info>One of the most talented actresses on Daytime. Kassie
      plays the devious and beautiful Blair Cramer on ABC&apos;s
      &quot;One Life To Live.&quot;</misc-info>
  </person>
  <person employee-number="A7987" family-name="Smith" first-name="Joe">
    <contact-info>
      <email address="joes@iro.ibm.com"/>
      <mobile-phone number="888-7657765"/>
      <home-phone number="03-8767898"/>
      <home-phone number="03-8767871"/>
    </contact-info>
    <address city="New York" number="12789" state="NY" street="W. 15th Ave."/>
    <job-info employee-type="Part-Time" is-manager="no" job-description="Hacker"/>
    <manager employee-number="A7000"/>
  </person>
</addressbook>
'! !

!RzExamples methodsFor: 'scenario' stamp: ''!
buildPendrive
	| t1 t2 t3 t4 t5 |
	t1 := RSPenDrive new.
	t2 := RSDirectory new.
	t2
		add: (RSMP3File named: 'MP3A' size: 10).
	t2
		add: (RSMP3File named: 'MP3B' size: 10).
	t2
		add: (RSMP3File named: 'MP3C' size: 10).
	t2
		add: (RSMP3File named: 'MP3D' size: 10).
	t2
		add: (RSMP3File named: 'MP3E' size: 10).
	t2
		add: (RSMP3File named: 'MP3F' size: 10).
	t3 := RSDirectory new.
	t3
		add: (RSMP3File named: 'MP4A' size: 10).
	t3
		add: (RSMP3File named: 'MP4B' size: 10).
	t3
		add: (RSMP3File named: 'MP4C' size: 10).
	t3
		add: (RSMP3File named: 'MP4D' size: 10).
	t3
		add: (RSMP3File named: 'MP4E' size: 10).
	t3
		add: (RSMP3File named: 'MP4F' size: 10).
	t4 := RSDirectory new.
	t4
		add: (RSTextFile named: 'TextA' size: 10).
	t4
		add: (RSTextFile named: 'TextB' size: 10).
	t4
		add: (RSTextFile named: 'TextC' size: 10).
	t4
		add: (RSTextFile named: 'TextD' size: 10).
	t4
		add: (RSTextFile named: 'TextE' size: 10).
	t4
		add: (RSTextFile named: 'TextF' size: 10).
	t5 := RSDirectory new.
	t5
		add: (RSImageFile named: 'ImageA').
	t5
		add: (RSImageFile named: 'ImageB').
	t5
		add: (RSImageFile named: 'ImageC').
	t5
		add: (RSImageFile named: 'ImageD').
	t5
		add: (RSImageFile named: 'ImageE').
	t5
		add: (RSImageFile named: 'ImageF').
	t1 add: t2.
	t1 add: t3.
	t1 add: t4.
	t1 add: t5.
	^ t1! !

!RzExamples methodsFor: 'examples' stamp: ''!
exampleBuilder1
	| t1 t2 |
	t2 := RzBuilder new.
	t2
		define: #input
		named: #x
		with: #(0 1 ).
	t2
		define: #input
		named: #y
		with: #(0 1 ).
	t2
		define: #input
		named: #z
		with: #(0 1 ).
	t1 := t2
				execute: [:t3 :t4 :t5 | t3 asString , t4 asString , t5 asString].
	t1 values
		do: [:t3 | Transcript show: t3;
				 cr].
	Transcript show: ' ( 1, 0 , 1) => ';
		
		show: (t1 at: #(1 0 1 ));
		 cr! !

Object subclass: #RzRizelDemo
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Rizel-Example'!

!RzRizelDemo methodsFor: 'benchmarks' stamp: ''!
benchmark1
	(self buildPendrive
		collect: [:t1 | t1 class = RSTextFile])
		do: #open! !

!RzRizelDemo methodsFor: 'benchmarks' stamp: ''!
benchmark2
	(self buildPendrive
		collect: [:t1 | t1 class = RSMP3File])
		do: #open! !

!RzRizelDemo methodsFor: 'benchmarks' stamp: ''!
benchmark3
	(self buildPendrive
		collect: [:t1 | t1 class = RSImageFile])
		do: #open! !

!RzRizelDemo methodsFor: 'benchmarks' stamp: ''!
benchmark4
	(self buildPendrive
		collect: [:t1 | t1 class = RSMP4File])
		do: #open! !

!RzRizelDemo methodsFor: 'benchmarks' stamp: ''!
buildPendrive
	| t1 t2 t3 t4 t5 |
	t1 := RSPenDrive new.
	t2 := RSDirectory new.
	t2
		add: (RSMP3File named: 'MP3A' size: 10).
	t2
		add: (RSMP3File named: 'MP3B' size: 10).
	t2
		add: (RSMP3File named: 'MP3C' size: 10).
	t2
		add: (RSMP3File named: 'MP3D' size: 10).
	t2
		add: (RSMP3File named: 'MP3E' size: 10).
	t2
		add: (RSMP3File named: 'MP3F' size: 10).
	t3 := RSDirectory new.
	t3
		add: (RSMP4File named: 'MP4A' size: 10).
	t3
		add: (RSMP4File named: 'MP4B' size: 10).
	t3
		add: (RSMP4File named: 'MP4C' size: 10).
	t3
		add: (RSMP4File named: 'MP4D' size: 10).
	t3
		add: (RSMP4File named: 'MP4E' size: 10).
	t3
		add: (RSMP4File named: 'MP4F' size: 10).
	t4 := RSDirectory new.
	t4
		add: (RSTextFile named: 'TextA' size: 10).
	t4
		add: (RSTextFile named: 'TextB' size: 10).
	t4
		add: (RSTextFile named: 'TextC' size: 10).
	t4
		add: (RSTextFile named: 'TextD' size: 10).
	t4
		add: (RSTextFile named: 'TextE' size: 10).
	t4
		add: (RSTextFile named: 'TextF' size: 10).
	t5 := RSDirectory new.
	t5
		add: (RSImageFile named: 'ImageA' size: 10).
	t5
		add: (RSImageFile named: 'ImageB' size: 10).
	t5
		add: (RSImageFile named: 'ImageC' size: 10).
	t5
		add: (RSImageFile named: 'ImageD' size: 10).
	t5
		add: (RSImageFile named: 'ImageE' size: 10).
	t5
		add: (RSImageFile named: 'ImageF' size: 10).
	t1 add: t2.
	t1 add: t3.
	t1 add: t4.
	t1 add: t5.
	^ t1! !

!RzRizelDemo methodsFor: 'testing' stamp: ''!
executionTimeBenchmark1
	| t1 t2 t3 t4 |
	t3 := RzBuilder new.
	t1 := #('1' '2' '3' '4' '5' ).
	t3
		define: #input
		named: #version
		with: t1.
	t4 := t3
				execute: [:t5 | 
					Gofer new url: 'http://ss3.gemstone.com/ss/Rizel';
						 version: 'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.' , t5;
						 load.
					[self perform: #benchmark1] timeToRun].
	RzVisualizer1D new
		values: (t1
				collect: [:t5 | t4 at: RzVector <== t5]);
		 visualize! !

!RzRizelDemo methodsFor: 'testing' stamp: ''!
methodExecutionTime
	| t1 t2 t3 t4 t5 t6 |
	self reset.
	t6 := RzBuilder new.
	t6
		define: #input
		named: #version
		with: #('1' '4' ).
	Cache
		ifNil: [Cache := t6
						execute: [:t7 | 
							Gofer new url: 'http://ss3.gemstone.com/ss/Rizel';
								 version: 'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.' , t7;
								 load.
							Smalltalk garbageCollect.
							t6
								profile: [self perform: #benchmark3]
								inPackagesMatching: 'Rizel-Test-Scenario']].
	t5 := RzProfile
				merge: (Cache at: #('1' ))
				with: (Cache at: #('4' )).
	(RzVisualizerMerge on: t5) visualize! !

!RzRizelDemo methodsFor: 'testing' stamp: ''!
reset
	Cache := nil! !

!RzRizelDemo methodsFor: 'testing' stamp: ''!
totalExecutionTime
	| t1 t2 t3 t4 |
	t3 := RzBuilder new.
	t1 := #('1' '2' '3' '4' '5' ).
	t2 := #(#benchmark1 #benchmark2 #benchmark3 #benchmark4 ).
	t3
		define: #input
		named: #version
		with: t1.
	t3
		define: #input
		named: #benchmark
		with: t2.
	t4 := t3
				execute: [:t5 :t6 | 
					Gofer new url: 'http://ss3.gemstone.com/ss/Rizel';
						 version: 'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.' , t5;
						 load.
					[self perform: t6] timeToRun].
	RzVisualizer2D new xValues: t1;
		 yValues: t2;
		
		value: [:t5 :t6 | t4 at: RzVector <== t5 + t6];
		 padding: 150;
		 visualize! !
